function print_tt() {
    var ctt = new ClassTimeTable();
    ctt.createDivision();

    tableManager();
    announceManager();
}

function tableManager() {
    var ctt = new ClassTimeTable;
    
    var targetDivision = document.getElementById(ctt.getElementsid());
    var elementTable = ctt.createClasstimetable();
    var oldTable = document.getElementById('TBL_' + ctt.getElementsid());
    if (oldTable) {
        if (oldTable != elementTable) {
            targetDivision.replaceChild(elementTable, oldTable);
        }
    } else {
        targetDivision.appendChild(elementTable);
    }

    var waitTime = 0;
    var date = new Date();
    var waitTemp = 15 - ((date.getMinutes() % 15) + 1);
    waitTime += (waitTemp) * 60 * 1000;
    waitTemp = 60 - (date.getSeconds() + 1);
    waitTime += (waitTemp) * 1000;
    waitTime += 1002 - date.getMilliseconds();
    setTimeout('tableManager()', waitTime);
}

function announceManager() {
    var ctt = new ClassTimeTable;

    var nextClass = ctt.getNextclass();
    var currentClass = ctt.getCurrentclass()
    var nowDate = ctt.cYear.toString() + 'N' + ctt.cMonth.toString() + '' + ctt.cDate.toString() + '' + ctt.daysArray[ctt.cDay] + 'j';
    var nowTime;
    if (ctt.cHours.toString().length == 1) {
        nowTime = '0' + ctt.cHours.toString() + '';
    } else {
        nowTime = ctt.cHours.toString() + '';
    }
    if (ctt.cMinutes.toString().length == 1) {
        nowTime += '0' + ctt.cMinutes.toString() + '';
    } else {
        nowTime += ctt.cMinutes.toString() + '';
    }
    if (ctt.cSeconds.toString().length == 1) {
        nowTime += '0' + ctt.cSeconds.toString() + 'b';
    } else {
        nowTime += ctt.cSeconds.toString() + 'b';
    }

    var epTime = document.createElement('p');
    epTime.setAttribute('id', 'TAT_' + ctt.getElementsid());
    epTime.setAttribute('class', 'tmo_announce_time');
    epTime.setAttribute('className', 'tmo_announce_time');

    var epClass = document.createElement('p');
    epClass.setAttribute('id', 'TAC_' + ctt.getElementsid());
    epClass.setAttribute('class', 'tmo_announce_class');
    epClass.setAttribute('className', 'tmo_announce_class');

    var textNode;
    var elementNode;
    textNode = document.createTextNode('ݎ');
    epTime.appendChild(textNode);
    elementNode = document.createElement('strong');
    elementNode.setAttribute('class', 'time_announce');
    elementNode.setAttribute('className', 'time_announce');
    textNode = document.createTextNode(nowDate + ' ' + nowTime);
    elementNode.appendChild(textNode);
    epTime.appendChild(elementNode);
    textNode = document.createTextNode('B');
    epTime.appendChild(textNode);

    if (ctt.inClass()) {
        elementNode = document.createElement('strong');
        elementNode.setAttribute('class', 'class_announce');
        elementNode.setAttribute('className', 'class_announce');
        textNode = document.createTextNode(currentClass);
        elementNode.appendChild(textNode);
        epTime.appendChild(elementNode);
        textNode = document.createTextNode('JuB');
        epTime.appendChild(textNode);
    }

    textNode = document.createTextNode('̎Ƃ');
    epClass.appendChild(textNode);
    elementNode = document.createElement('strong');
    elementNode.setAttribute('class', 'class_announce');
    elementNode.setAttribute('className', 'class_announce');
    textNode = document.createTextNode(nextClass);
    elementNode.appendChild(textNode);
    epClass.appendChild(elementNode);
    textNode = document.createTextNode('łB');
    epClass.appendChild(textNode);

    var targetDivision = document.getElementById(ctt.getElementsid());
    oEpclass = document.getElementById('TAC_' + ctt.getElementsid());
    if (oEpclass) {
        targetDivision.replaceChild(epClass, oEpclass);
    } else {
        targetDivision.appendChild(epClass);
    }
    oEptime = document.getElementById('TAT_' + ctt.getElementsid());
    if (oEptime) {
        targetDivision.replaceChild(epTime, oEptime);
    } else {
        targetDivision.appendChild(epTime);
    }

    var waitTime = 1000;
    var date = new Date();
    waitTime -= date.getMilliseconds();
    setTimeout('announceManager()', waitTime);
}

function createClasstimetable() {
    var cols = (this.colNumber - 1) / 2;
    var rows = (this.rowNumber - 1) / 2;

    var tableName = this.getTablename();
    if (tableName == undefined) {
        tableName = this.schoolName + 'Ԋ';
    }

    var textNode;
    var elementNode;
    var elementTable = document.createElement('table');
    elementTable.setAttribute('id', 'TBL_' + this.getElementsid());
    elementTable.setAttribute('class', 'tmo_ctt');
    elementTable.setAttribute('className', 'tmo_ctt');

    elementNode = document.createElement('caption');
    textNode = document.createTextNode(tableName);
    elementNode.appendChild(textNode);
    elementTable.appendChild(elementNode);

    elementNode = document.createElement('col');
    elementNode.setAttribute('class', 'clock_time');
    elementNode.setAttribute('className', 'clock_time');
    elementTable.appendChild(elementNode);
    
    for (var i = cols * -1; i <= cols; i++) {
        if (i == 0) {
            elementNode = document.createElement('col');
            elementNode.setAttribute('class', 'today');
            elementNode.setAttribute('className', 'today');
            elementTable.appendChild(elementNode);
        } else {
            elementNode = document.createElement('col');
            elementNode.setAttribute('class', 'days');
            elementNode.setAttribute('className', 'days');
            elementTable.appendChild(elementNode);
        }
    }
    
    var elementTr;
    var elementThead = document.createElement('thead');
    elementTr = document.createElement('tr');
    elementNode = document.createElement('td');
    textNode = document.createTextNode(' ');
    elementNode.appendChild(textNode);
    elementTr.appendChild(elementNode);

    for (var i = cols * -1; i <= cols; i++) {
        var dayNum = this.cDay + i;
        if (dayNum < 0) {
            dayNum += 7;
        }
        if (dayNum > 6) {
            dayNum -= 7;
        }
        var dayName = this.daysArray[dayNum];
        elementNode = document.createElement('th');
        textNode = document.createTextNode(dayName);
        elementNode.appendChild(textNode);
        elementTr.appendChild(elementNode);
    }
    elementThead.appendChild(elementTr);
    elementTable.appendChild(elementThead);

    var elementTbody;
    for (var i = rows * -1; i <= rows; i++) {
        var cTime = this.cTime;
        cTime += ((i + 1) * 15 * 60 * 1000);
        var tTime = new Date();
        tTime.setTime(cTime);
        var tHours = tTime.getHours();
        var tMinutes = tTime.getMinutes();
        if (tMinutes < 15) {
            tMinutes = 0;
        } else if (tMinutes < 30) {
            tMinutes = 15;
        } else if (tMinutes <45) {
            tMinutes = 30;
        } else if (tMinutes < 60) {
            tMinutes = 45;
        }

        if ((tHours == 0 && tMinutes == 0) || i == rows * -1) {
            if (tTime.getDate() < this.cDate) {
                elementTbody = document.createElement('tbody');
                elementTbody.setAttribute('class', 'past');
                elementTbody.setAttribute('className', 'past');
            } else if (tTime.getDate() == this.cDate) {
                elementTbody = document.createElement('tbody');
                elementTbody.setAttribute('class', 'present');
                elementTbody.setAttribute('className', 'present');
            } else if (tTime.getDate() > this.cDate) {
                elementTbody = document.createElement('tbody');
                elementTbody.setAttribute('class', 'future');
                elementTbody.setAttribute('className', 'future');
            }
        }

        var tHead = tHours.toString();
        if (tHours.toString().length == 1) {
            tHead = '0' + tHead;
        }
        if (tMinutes.toString().length == 1) {
            tHead += ':0' + tMinutes.toString();
        } else {
            tHead += ':' + tMinutes.toString();
        }
        if (i == 0) {
            elementTr = document.createElement('tr');
            elementTr.setAttribute('class', 'nexttime');
            elementTr.setAttribute('className', 'nexttime');
        } else {
            elementTr = document.createElement('tr');
        }
        textNode = document.createTextNode(tHead);
        elementNode = document.createElement('th');
        elementNode.appendChild(textNode);
        elementTr.appendChild(elementNode);

        for (var j = cols * -1; j <= cols; j++) {
            var cTime = this.cTime;
            cTime += ((i + 1) * 15 * 60 * 1000);
            cTime += j * 24 * 60 * 60 * 1000;
            var tTime = new Date();
            tTime.setTime(cTime);
            var dayNum = tTime.getDay();
            var classId = this.getClassid(dayNum, tHours, tMinutes);
            var className = this.classArray[classId];
            if (i == 0 && j == 0) {
                textNode = document.createTextNode(className);
                elementNode = document.createElement('td');
                elementNode.setAttribute('class', 'next');
                elementNode.setAttribute('className', 'next');
                elementNode.appendChild(textNode);
                elementTr.appendChild(elementNode);
            } else {
                textNode = document.createTextNode(className);
                elementNode = document.createElement('td');
                elementNode.appendChild(textNode);
                elementTr.appendChild(elementNode);
            }
            elementTbody.appendChild(elementTr);
        }
        elementTable.appendChild(elementTbody);
    }
    return elementTable;
}

function getCurrentclass() {
    var tDay = this.cDay;
    var tHours = this.cHours;
    var tMinutes = this.cMinutes;
    
    var classId = this.getClassid(tDay, tHours, tMinutes);
    var className = this.getClassname(classId);

    return className;
}

function getNextclass() {
    var tDay = this.cDay;
    var tHours = this.cHours;
    var tMinutes = this.cMinutes;
    
    tMinutes += 15;
    if (tMinutes >= 60) {
        tMinutes %= 60;
        tHours += 1;
    }
    if (tHours >= 24) {
        tHours %= 24;
        tDay += 1;
    }
    if (tDay >= 7) {
        tDay %= 7;
    }
    var classId = this.getClassid(tDay, tHours, tMinutes);
    var className = this.getClassname(classId);

    return className;
}

function getClassname(classId) {
    var className = this.classArray[classId];
    return className;
}

function getClassid(tDay, tHours, tMinutes) {
    if (tDay == undefined) {
        tDay = this.cDay;
    }
    if (tHours == undefined) {
        tHours = this.cHours;
    }
    if (tMinutes == undefined) {
        tMinutes = this.cMinutes;
    }
    var classId = 0;
    if (tHours % 2 == 1) {
        classId = 4;
    }
    classId += tDay;
    classId += Math.floor(tMinutes / 15);
    if (tDay == 0) {
        classId -= 2;
    } else {
        classId -= 1;
    }
    if (classId < -1) {
        classId = 6;
    } else if (classId < 0) {
        classId = 7;
    }
    classId %= 8;

    return classId;
}

function setElementsid(elementsId) {
    this.elementsId = elementsId;
}

function getElementsid() {
    return this.elementsId;
}

function createDivision() {
    var elementsId = this.getElementsid();
    document.write('<div id="' + elementsId + '"></div>');
}

function setTablename(tableName) {
    this.tableName = tableName;
}

function getTablename() {
    return this.tableName;
}

function setSchoolname (schoolName) {
    this.schoolName = schoolName;
}

function setColnumber(colNumber) {
    if (colNumber == undefined) {
        this.colNumber = 7;
    } else if (colNumber % 2 == 0) {
        this.colNumber = colNumber + 1;
    } else {
        this.colNumber = colNumber;    
    }
    if (this.colNumber > 7) {
        this.colNumber = 7;
    }
}

function setRownumber(rowNumber) {
    if (rowNumber == undefined) {
        this.rowNumber = 7;
    } else if (rowNumber % 2 == 0) {
        this.rowNumber = rowNumber + 1;
    } else {
        this.rowNumber = rowNumber;
    }
}

function inClass(cMinutes) {
    if (cMinutes == undefined) {
        cMinutes = this.cMinutes;
    }
    if (cMinutes % 15 < this.courseHour) {
        return true;
    } else {
        return false;
    }
}

function ClassTimeTable(colNumber, rowNumber) {
    this.courseHour = 6;
    this.schoolName = '̍Z';
    this.tableName;
    this.daysArray = new Array('', '', '', '', '', '', 'y');
    this.classArray = new Array('', 'w', '', 'Љ', 'O', '̈', '|p', 'ƒ');
    this.elementsId = 'TMO_CTT_TARGET';

    var objDate = new Date();
    this.cYear = objDate.getFullYear();
    this.cMonth = objDate.getMonth();
    this.cMonth += 1;
    this.cDate = objDate.getDate();
    this.cDay = objDate.getDay();
    this.cHours = objDate.getHours();
    this.cMinutes = objDate.getMinutes();
    this.cSeconds = objDate.getSeconds();
    this.cTime = objDate.getTime();

    if (colNumber == undefined) {
        this.colNumber = 7;
    } else if (colNumber % 2 == 0) {
        this.colNumber = colNumber + 1;
    } else {
        this.colNumber = colNumber;    
    }
    if (this.colNumber > 7) {
        this.colNumber = 7;
    }
    
    if (rowNumber == undefined) {
        this.rowNumber = 7;
    } else if (rowNumber % 2 == 0) {
        this.rowNumber = rowNumber + 1;
    } else {
        this.rowNumber = rowNumber;
    }
}

new ClassTimeTable();
ClassTimeTable.prototype.getCurrentclass = getCurrentclass;
ClassTimeTable.prototype.getNextclass = getNextclass;
ClassTimeTable.prototype.getClassname = getClassname;
ClassTimeTable.prototype.getClassid = getClassid;
ClassTimeTable.prototype.setTablename = setTablename;
ClassTimeTable.prototype.getTablename = getTablename;
ClassTimeTable.prototype.setElementsid = setElementsid;
ClassTimeTable.prototype.getElementsid = getElementsid;
ClassTimeTable.prototype.createDivision = createDivision;
ClassTimeTable.prototype.setSchoolname = setSchoolname;
ClassTimeTable.prototype.setColnumber = setColnumber;
ClassTimeTable.prototype.setRownumber = setRownumber;
ClassTimeTable.prototype.createClasstimetable = createClasstimetable;
ClassTimeTable.prototype.inClass = inClass;
